Attribute VB_Name = "DEFINITION_FORME_3D"

Public Const sTitle As String = "IGES-tool V0.3.0"

'---------------------------------------------------------------------------
' Point en 2D
'---------------------------------------------------------------------------
Public Type Point2
    X As Double
    Y As Double
End Type

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type

'---------------------------------------------------------------------------
' Lines in 3D
'---------------------------------------------------------------------------
Public Type Line3
    ' Line is L(t) = b+t*m for any real-valued t
    ' Ray has constraint t >= 0, b is the origin of the ray
    ' Line segment has constraint 0 <= t <= 1, b and b+m are end points
    B As Point3
    M As Point3
End Type

'---------------------------------------------------------------------------
' Circles in 3D
'---------------------------------------------------------------------------
Public Type Circle3
    ' Plane containing circle is Dot(N,X-C) = 0 where X is any point in the
    ' plane.  Vectors U, V, and N form an orthonormal right-handed set
    ' (matrix [U V N] is orthonormal and has determinant 1).  Circle within
    ' the plane is parameterized by X = C + R*(cos(A)*U + sin(A)*V) where
    ' A is an angle in [0,2*pi).
    U As Point3 ' coordinate system of plane containing
    V As Point3
    N As Point3
    C As Point3 ' center
    R As Double ' radius > 0
End Type

'---------------------------------------------------------------------------
' Planes in 3D
'---------------------------------------------------------------------------
Public Type Plane3
    ' plane is Dot(N,X) = d
    N As Point3
    D As Double
End Type

'---------------------------------------------------------------------------
'Poche en 3D avec Rayon
'---------------------------------------------------------------------------
Public Type Poche_Rectangulaire3D
   NOM As String
   COMMENTAIRE As String
   Centre As Point3         ' Centre de la Poche
   Axes(2) As Point3        ' Vecteur orientation de la Poche
   Longueurs(2) As Double   ' Longueur de la Poche
   Rayon As Double          ' Rayon de la Poche
End Type

Public Type Poche_Oblong3D
   NOM As String
   COMMENTAIRE As String
   Centre As Point3         ' Centre de la Poche
   Axes(2) As Point3        ' Vecteur orientation de la Poche
   Longueurs(2) As Double   ' Longueur de la Poche
End Type

Public Type Poche_Circulaire3D
   NOM As String
   COMMENTAIRE As String
   Centre As Point3         ' Centre de la Poche
   Axes(2) As Point3        ' Vecteur orientation de la Poche
   Hauteur As Double
   Rayon As Double          ' Rayon de la Poche
   Forme As Integer         ' Forme de la poche
                            '   0= fond plat
                            '   1= Fond dbouchant
   Rayon_Fond As Double     ' Rayon_fond ( pour trou debouchant )
   
   Angle_Lamage As Double
   Rayon_Lamage As Double
   Diametre_Lamage As Double
   Prof_Lamage As Double
   
End Type

Public Type Poche_Contour3D
   NOM As String
   COMMENTAIRE As String
   Centre As Point3         ' Centre de la Poche
   Axes(2) As Point3        ' Vecteur orientation de la Poche
   Longueurs(2) As Double   ' Longueur de la Poche
End Type

Public Type Biblio3D
    NOM          As String      ' Nom de la librairie
    FICHIER      As String      ' FICHIER ORIGINE
    COMMENTAIRE  As String      ' COMMENTAIRE
    NB_FEAT      As Integer     ' Nombre FEATURE

    NB_Poche_Circulaire3D As Integer
    TAB_Poche_Circulaire3D() As Poche_Circulaire3D
    
    NB_Poche_Oblong3D As Integer
    TAB_Poche_Oblong3D() As Poche_Oblong3D
    
    NB_Poche_Rectangulaire3D As Integer
    TAB_Poche_Rectangulaire3D() As Poche_Rectangulaire3D
End Type


Public Type FEAT_POSITION
    POS      As Point3  ' 3347.5022, -430.0000,  630.6489
    DIR_X    As Point3  '    0.000000, -1.000000,  0.000000
    DIR_Y    As Point3  '   -0.017452,  0.000000,  0.999848
    DIR_Z    As Point3  '   -0.999848,  0.000000, -0.017452
End Type

'Global variables


Public BIBLIOTHEQUE3D As Biblio3D

