Attribute VB_Name = "ECRITURE_IGES_FEATURE"
Option Explicit
Public Current_Ligne_uSer As Integer
Public Current_Ligne_Parameter As Integer
Public Current_Ligne_Definition As Integer
' variables Log
Public PMIN As Interpolation
Public PMAX As Interpolation


Public Type Matrix
    A1 As Double
    B1 As Double
    C1 As Double
    A2 As Double
    B2 As Double
    C2 As Double
    A3 As Double
    B3 As Double
    C3 As Double
End Type

Public Type Interpolation
    Coord As Point3
    'Pos As PosAngulaire
End Type

Public oldxyz As Interpolation
Public Const epsilon As Double = 0.000000000000001
Public Const Tolerance As Double = 0.00001
Public allClosest  As Point3


' Ecriture d'un fichier rapport
' Fichier non du fichier rapport a ouvrir en ajout
' Fichier in non du fichier RML trait
' Fichier out non du fichier NC cr

Public Sub Ecriture_SectionS(FICHIER As String)
Dim Numero As Integer
Dim cpt As Integer

Dim compteur As Integer
   Open FICHIER For Output As #3
        Print #3, format_80_colones("************************************************************************", "S", 0, 1)
        Print #3, format_80_colones("DATE             : " & Now, "S", 0, 2)
        Print #3, format_80_colones(" FICHIER FEATURE : " & BIBLIOTHEQUE3D.FICHIER, "S", 0, 3)
        Print #3, format_80_colones("************************************************************************", "S", 0, 4)
    Close #3        ' Ferme le fichier.

    Current_Ligne_uSer = 4

End Sub

Public Sub Ecriture_SectionG(FICHIER As String)
    Open FICHIER For Append As #3
    Print #3, ",,,,,8HIGES 5.1,32,45,7,324,15,,1.,2,2HMM,1,0.35,13H030218.122354,      G0000001"
    Print #3, "1.D-05,0.,,,4,0,13H030218.122354;                                       G0000002"
    Close #3        ' Ferme le fichier.
End Sub

Public Sub Ecriture_SectionD(FICHIER As String, Entity_id As Integer, Parameter_line As Integer, Line_count As Integer, Transfo_matrix As Integer, Color As Integer, Visible As Integer, Dependant As Integer, Optional Forme As Integer)
    
    Open FICHIER For Append As #3
    
    Select Case Entity_id
    
    Case 100  'Cercle
        Print #3, DE_section_A(100, Parameter_line - Line_count, Transfo_matrix, Visible, Dependant, Current_Ligne_Definition)
        Print #3, DE_section_B(100, Line_count, Color, Current_Ligne_Definition + 1)
    
    Case 102  'Courbes lies
        Print #3, DE_section_A(102, Parameter_line - Line_count, Transfo_matrix, Visible, 0, Current_Ligne_Definition)
        Print #3, DE_section_B(102, Line_count, Color, Current_Ligne_Definition + 1)
        
   Case 108 'Plane
        Print #3, DE_section_A(108, Parameter_line - Line_count, Transfo_matrix, Visible, 0, Current_Ligne_Definition)
        Print #3, DE_section_B(108, Line_count, Color, Current_Ligne_Definition + 1, Forme)
    
    
    Case 110  'Line
        Print #3, DE_section_A(110, Parameter_line - Line_count, Transfo_matrix, Visible, Dependant, Current_Ligne_Definition)
        Print #3, DE_section_B(110, Line_count, Color, Current_Ligne_Definition + 1)

    Case 116  'Point
        Print #3, DE_section_A(116, Parameter_line - Line_count, Transfo_matrix, Visible, Dependant, Current_Ligne_Definition)
        Print #3, DE_section_B(116, Line_count, Color, Current_Ligne_Definition + 1)
    
    Case 120 'Surface de rvolution
        Print #3, DE_section_A(120, Parameter_line - Line_count, 0, Visible, Dependant, Current_Ligne_Definition)
        Print #3, DE_section_B(120, Line_count, Color, Current_Ligne_Definition + 1)
        
        
    Case 122 'Tabulated cylinder
        Print #3, DE_section_A(122, Parameter_line - Line_count, 0, Visible, 0, Current_Ligne_Definition)
        Print #3, DE_section_B(122, Line_count, 2, Current_Ligne_Definition + 1)
        
    Case 124  'Axis
        Print #3, DE_section_A(124, Parameter_line - Line_count, 0, Visible, 0, Current_Ligne_Definition)
        Print #3, DE_section_B(124, Line_count, 2, Current_Ligne_Definition + 1)
         
    Case 142  'Curbe on a parametric surface
        Print #3, DE_section_A(142, Parameter_line - Line_count, 0, Visible, Dependant, Current_Ligne_Definition)
        Print #3, DE_section_B(142, Line_count, Color, Current_Ligne_Definition + 1)
        
    Case 144  'Trimmed parametric surface
        Print #3, DE_section_A(144, Parameter_line - Line_count, 0, Visible, Dependant, Current_Ligne_Definition)
        Print #3, DE_section_B(144, Line_count, Color, Current_Ligne_Definition + 1)
        
    Case 212  'General note entity
        Print #3, DE_section_A(212, Parameter_line - Line_count, 0, Visible, 0, Current_Ligne_Definition)
        Print #3, DE_section_B(212, Line_count, 2, Current_Ligne_Definition + 1)
    
    Case 314  'Couleur
        Print #3, DE_section_A(314, Parameter_line - Line_count, 0, 0, 0, Current_Ligne_Definition, 0)
        Print #3, DE_section_B(314, Line_count, 2, Current_Ligne_Definition + 1)
     
    Case Else
        Beep
    End Select
    
    Current_Ligne_Definition = Current_Ligne_Definition + 2
    
    Close #3        ' Ferme le fichier.
End Sub
' Definition Cercle
Public Sub Ecriture_SectionP_100(FICHIER As String, Center As Point3, P1 As Point3, P2 As Point3, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
    Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "100,"
        string_tempoA = string_tempoA & Format(0, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Center.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Center.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(P1.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(P1.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(P2.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(P2.Y, "#0.0000") & ";"
        
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub
' Definition Courbes lies
Public Sub Ecriture_SectionP_102(FICHIER As String, Nb_entity As Integer, tab_entity() As Integer, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
    Dim SVG_Parameter_line As Integer
    Dim I As Integer
    
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3

        string_tempoA = "102,"
        string_tempoA = string_tempoA & Nb_entity & ","
        
        For I = 0 To Nb_entity - 1
            string_tempoA = string_tempoA & tab_entity(I) & ","
        Next I
        
        string_tempoA = string_tempoA & ";"
        
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line

    Close #3        ' Ferme le fichier.
End Sub
' Definition Ligne
Public Sub Ecriture_SectionP_110(FICHIER As String, Entity As Line3, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
   Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
   Open FICHIER For Append As #3
    

        string_tempoA = "110,"
        string_tempoA = string_tempoA & Format(Entity.B.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.B.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.B.Z, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.M.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.M.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.M.Z, "#0.0000") & ";"
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub
' Definition Point
Public Sub Ecriture_SectionP_116(FICHIER As String, Entity As Point3, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
    Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "116,"
        string_tempoA = string_tempoA & Format(Entity.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.Z, "#0.0000") & ",0;"
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub
' CURVE ON A PARAMETRIC SURFACE ENTITY
Public Sub Ecriture_SectionP_120(FICHIER As String, Pointeur_Courbe_Axis As Long, Pointeur_Courbe_Generatrice As Long, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
   Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "120,"
        string_tempoA = string_tempoA & Pointeur_Courbe_Axis & ","
        string_tempoA = string_tempoA & Pointeur_Courbe_Generatrice & ","
                string_tempoA = string_tempoA & Format(0, "#0.0000") & "," 'Start angle en radians
        string_tempoA = string_tempoA & Format(2 * PI, "#0.0000") & ";" 'End angle angle en radians
        
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub

' Tabulated cylinder
Public Sub Ecriture_SectionP_122(FICHIER As String, Entity As Point3, Composite_curve As Long, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
    Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "122,"
        string_tempoA = string_tempoA & Composite_curve & ","
        string_tempoA = string_tempoA & Format(Entity.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.Z, "#0.0000") & ";"
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub

' Ruled surface
Public Sub Ecriture_SectionP_108(FICHIER As String, Plane As Plane3, Composite_curve As Long, PtOrg As Point3, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
    Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "108,"
        string_tempoA = string_tempoA & Format(Plane.N.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Plane.N.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Plane.N.Z, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Plane.D, "#0.0000") & ","
        string_tempoA = string_tempoA & Composite_curve & ","
        string_tempoA = string_tempoA & Format(PtOrg.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(PtOrg.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(PtOrg.Z, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Plane.N.Z, "#0.0000") & ",1.;"
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub


' Definition Matrix
Public Sub Ecriture_SectionP_124(FICHIER As String, Entity As Matrix, Centre As Point3, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
    Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "124,"
        string_tempoA = string_tempoA & Format(Entity.A1, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.A2, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.A3, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Centre.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.B1, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.B2, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.B3, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Centre.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.C1, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.C2, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Entity.C3, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Centre.Z, "#0.0000") & ";"
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub
' CURVE ON A PARAMETRIC SURFACE ENTITY
Public Sub Ecriture_SectionP_142(FICHIER As String, Pointeur_surface As Long, Pointeur_courbe As Long, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
   Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "142,"
        string_tempoA = string_tempoA & "0,"  ' indique la facon selon laquelle la courbe a te cre :
                                              ' 0= non spcifi
                                              ' 1 Projection de la courbe sur la surface
                                              ' 2 intersection de deux surfaces
                                              ' 3 Courbe Isoparametrique
        string_tempoA = string_tempoA & Pointeur_surface & ","
        string_tempoA = string_tempoA & "0,"   ' Pointeur DE sur la courbe paramrique Moi j'en ai pas donc 0 et je force le dernier paramtre  C prfr
                                                ' = devrai forc  prendre courbe 3d
        string_tempoA = string_tempoA & Pointeur_courbe & ","
        string_tempoA = string_tempoA & "2;"   'indique la mthode prfre pour crer la courbre
                                                ' 0 Non  spcifie
                                                ' 1 Courbe paramtrique prfre
                                                ' 2 Courbe C 3d Prfr
                                                ' 3 Courbe C ou coubre paramtrique pas de prfrence
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub



' TRIMMED (PARAMETRIC) SURFACE ENTITY
' Ici je ne gre qu'une courbe extrieure
' et une courbe intrieure
Public Sub Ecriture_SectionP_144(FICHIER As String, Pointeur_surface As Long, Pointeur_courbe_ext As Long, Pointeur_courbe_int As Long, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
    Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "144,"
        string_tempoA = string_tempoA & Pointeur_surface & ","
        string_tempoA = string_tempoA & "1,"     '0: la courbe bord extrieur de la surface est la limite de la face autrement =1
        string_tempoA = string_tempoA & "1,"  ' nombre de courbe intrieur ici =1
        string_tempoA = string_tempoA & Pointeur_courbe_ext & ","
        string_tempoA = string_tempoA & Pointeur_courbe_int & ";"
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub
' General note entity
Public Sub Ecriture_SectionP_212(FICHIER As String, Texte As String, Centre As Point3, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim TEXT_LONG As Integer
   Dim string_tempoA As String
   Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    
    TEXT_LONG = Len(Texte)

        string_tempoA = "212,"
        ' une chaine
        string_tempoA = string_tempoA & "1,"
        ' Longeur chaine
        string_tempoA = string_tempoA & TEXT_LONG & ","
        ' Box Width
        string_tempoA = string_tempoA & Format(1, "#0.0") & ","
        ' Box height
        string_tempoA = string_tempoA & Format(8, "#0.0") & ","
        ' Font code
        string_tempoA = string_tempoA & "1,"
        'Slant angle en radian
        string_tempoA = string_tempoA & Format(0, "#0.000") & ","
        'Rotation angle in Radian
        string_tempoA = string_tempoA & Format(0, "#0.000") & ","
        ' Mirror Flag
        string_tempoA = string_tempoA & "0,"
        ' Rotate Flag
        string_tempoA = string_tempoA & "0,"
        ' Origine
        string_tempoA = string_tempoA & Format(Centre.X, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Centre.Y, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(Centre.Z, "#0.0000") & ","
        'texte avec sa longueur
        string_tempoA = string_tempoA & TEXT_LONG & "H" & Texte & ",0,0;"
        
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub
' COLOR DEF
Public Sub Ecriture_SectionP_314(FICHIER As String, couleur As CouleurRVB, Parameter_line As Integer, Num_line As Integer, Line_count As Integer)
   Dim string_tempoA As String
   Dim SVG_Parameter_line As Integer
    
   SVG_Parameter_line = Parameter_line
    Open FICHIER For Append As #3
    

        string_tempoA = "314," & string_tempoA & Format(couleur.Rouge, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(couleur.Vert, "#0.0000") & ","
        string_tempoA = string_tempoA & Format(couleur.Bleu, "#0.0000") & ";"
    
        Print #3, format_80_colones(string_tempoA, "P", Num_line, Parameter_line)
        Line_count = Parameter_line - SVG_Parameter_line
        

    Close #3        ' Ferme le fichier.
End Sub

Function DE_section_A(Entity_type As Integer, Parameter_line As Integer, tranfo_matrix As Integer, Visible As Integer, Dependant As Integer, Number As Integer, Optional Level As Integer = 1) As String
Dim string_tempoA As String
   
' Entity type number
    string_tempoA = "     " & Entity_type
' Parameter Data
    string_tempoA = string_tempoA & format_8(Parameter_line)
' Structure
    string_tempoA = string_tempoA & "       0"
' Line Font Patern
    string_tempoA = string_tempoA & "       0"
' Level ( LAYER )
    string_tempoA = string_tempoA & format_8(Level) '& "       1"
' View
    string_tempoA = string_tempoA & "       0"
' Tranformation matrix
    string_tempoA = string_tempoA & format_8(tranfo_matrix)
    
' Label Display Associativity
    string_tempoA = string_tempoA & "       0"

' Status_Number
    string_tempoA = string_tempoA & "0" & Visible & "0" & Dependant & "0001"

' Section Code
    string_tempoA = string_tempoA & "D" & Format(Number, "0000000")
    
    DE_section_A = string_tempoA
End Function

Function DE_section_B(Entity_type As Integer, Line_count As Integer, Color As Integer, Number As Integer, Optional Forme As Integer = 1) As String
Dim string_tempoB As String
Dim Form_type As String
Dim String_Entity As String
'Forme de l'entit
Form_type = "       0"

    Select Case Entity_type
    
    Case 100  'Cercle
                      ' "12345678"
        String_Entity = "CIRCLE  "
    Case 102  'Line
        String_Entity = "COMPOSIT"
    Case 108  'Plane
        String_Entity = "PLANE   "
        ' forme 1 car ici plane bounded Positif
        Form_type = "       " & Forme
    Case 110  'Line
        String_Entity = "LINE    "
    Case 116  'Point
        String_Entity = "POINT   "
    
    Case 120  'SURFACE DE REVOLUTIONR
        String_Entity = "REVSURF "
        
    Case 122  'TABULATED CYLINDER
        String_Entity = "TABULATE"

        
    Case 124  'Axis
        String_Entity = "AXIS    "
    
    Case 142  'Curve on a surface
        String_Entity = "CONS    "
        
    Case 144  'Trimed
        String_Entity = "FACE    "
        
    Case 212  'General note entity
        String_Entity = "SPACETXT"
        
    Case 314  'COULEUR DEF
        String_Entity = "COLOR   "
        
    End Select
    
' Entity type number
    string_tempoB = "     " & Entity_type
' Line Weight number
    string_tempoB = string_tempoB & "       0"
' Color Number
        '0 No color
        '1 Black
        '2 Red
        '3 Green
        '4 Blue
        '5 Yellow
        '6 Magenta
        '7 Cyan
        '8 White
   string_tempoB = string_tempoB & format_8(Color)

' Parameter Line Count Number
    string_tempoB = string_tempoB & format_8(Line_count)

' Form Number
    string_tempoB = string_tempoB & Form_type

' Reverse for future use
    string_tempoB = string_tempoB & "       0"
    
' Reverse for future use
    string_tempoB = string_tempoB & "       0"

' Entity Label
    string_tempoB = string_tempoB & String_Entity
    
' Entity subscript Number
    string_tempoB = string_tempoB & "00000001"
    
' Section code And sequence Number
string_tempoB = string_tempoB & "D" & Format(Number, "0000000")
DE_section_B = string_tempoB

End Function

Public Sub Ecriture_SectionT(FICHIER As String, Sect_S As Integer, Sect_G As Integer, Sect_D As Integer, Sect_P As Integer)
    Open FICHIER For Append As #3
    Print #3, "S" & Format(Sect_S, "0000000") & "G" & Format(Sect_G, "0000000") & "D" & Format(Sect_D, "0000000") & "P" & Format(Sect_P, "0000000") & "                                        T0000001"
    Close #3        ' Ferme le fichier.
End Sub

Public Function format_80_colones(Chaine As String, Section As String, Numero_entity As Integer, Numero_ligne As Integer) As String
Dim Longueur As Integer
Dim Lg_Temp As Integer
Dim string_tempoA As String
Dim string_tempoB As String
Dim string_tempoC As String
Dim I As Integer

Longueur = Len(Chaine)

Select Case Section
Case "S"
    If Longueur < 72 Then
    string_tempoA = Chaine
    For I = Longueur + 1 To 72
        string_tempoA = string_tempoA + " "
    Next I
        string_tempoA = string_tempoA & Section & Format(Numero_ligne, "0000000")
    Else
        string_tempoA = Mid$(Chaine, 1, 72) & Section & Format(Numero_ligne, "0000000")
    End If
    format_80_colones = string_tempoA
    Numero_ligne = Numero_ligne + 1
    
Case "P"
    string_tempoA = Chaine
    If Longueur < 64 Then
        For I = Longueur + 1 To 64
            string_tempoA = string_tempoA + " "
             
        Next I
        string_tempoA = string_tempoA & format_8(Numero_entity) & Section & Format(Numero_ligne, "0000000")
        format_80_colones = string_tempoA
        Numero_ligne = Numero_ligne + 1
    Else

again:
        
        string_tempoB = TokRightLeft(Mid$(string_tempoA, 1, 64), ",")
        Lg_Temp = Len(string_tempoB) + 1
        
        string_tempoC = string_tempoC & format_64(Mid$(string_tempoA, 1, Lg_Temp)) & format_8(Numero_entity) & Section & Format(Numero_ligne, "0000000") + Chr(13) + Chr(10)
        
        Numero_ligne = Numero_ligne + 1
        
        string_tempoA = Mid$(string_tempoA, Lg_Temp + 1, Len(string_tempoA))
        If Len(string_tempoA) > 64 Then GoTo again
        
        string_tempoA = format_64(string_tempoA) & format_8(Numero_entity) & Section & Format(Numero_ligne, "0000000")
        
        Numero_ligne = Numero_ligne + 1
        format_80_colones = string_tempoC + string_tempoA
        Debug.Print string_tempoC + string_tempoA
    End If
   
    
Case Else
 Beep
 MsgBox "Format Section invalide"
End Select

End Function

Public Function format_8(val As Integer) As String
Dim string_tempoA As String
Dim string_tempoB As String

Dim I As Integer

string_tempoB = val

For I = 1 To 8 - Len(string_tempoB)
string_tempoA = string_tempoA + " "
Next I
format_8 = string_tempoA & string_tempoB

End Function

Public Function format_64(string_tempoB As String) As String
Dim string_tempoA As String

Dim I As Integer

For I = 1 To 64 - Len(string_tempoB)
string_tempoA = string_tempoA + " "
Next I

format_64 = string_tempoB & string_tempoA

End Function

Public Sub concat(FICHIER As String, Fichier_in As String)
  Dim Donneslues As String
  
    Open FICHIER For Append As #3
    Open Fichier_in For Input As #4

    Do While Not EOF(4) ' Cherche la fin du fichier.
        Line Input #4, Donneslues  ' Lit une ligne de donnes.
        Print #3, Donneslues ' Ecrit une ligne de donnes.
    Loop
    
    Close #4
    Close #3        ' Ferme le fichier.
End Sub

Sub Ecriture_IGES(ByVal fic_out As String)
Dim indice As Integer
Dim Color_f As CouleurRVB

On Error GoTo fin

'Initialise les variables de contrle et de calcul
 Current_Ligne_Parameter = 1
 Current_Ligne_Definition = 1
 
 'Ecriture d'une couleur
            
   Color_f.Rouge = 130
   Color_f.Vert = 130
   Color_f.Bleu = 130
   Call Ecriture_SectionP_314(fic_out & "~P", Color_f, Current_Ligne_Parameter, Current_Ligne_Definition, 1)
   Call Ecriture_SectionD(fic_out & "~D", 314, Current_Ligne_Parameter, 1, 0, ColorIges("Texte"), 0, 0)


     'Ecriture des Circulaires
    For indice = 1 To BIBLIOTHEQUE3D.NB_Poche_Circulaire3D
        Call traitement_iges_function_circulaire(fic_out, BIBLIOTHEQUE3D.TAB_Poche_Circulaire3D(indice))
    Next indice
    Call MessageLOG_Print("Ecriture IGES " & indice - 1 & " Circulaire(s)")
    
    'Ecriture des Oblongs
    For indice = 1 To BIBLIOTHEQUE3D.NB_Poche_Oblong3D
        Call traitement_iges_function_slot(fic_out, BIBLIOTHEQUE3D.TAB_Poche_Oblong3D(indice))
    Next indice
    Call MessageLOG_Print("Ecriture IGES " & indice - 1 & " Oblong(s)")
    
     'Ecriture des Rectangles
    For indice = 1 To BIBLIOTHEQUE3D.NB_Poche_Rectangulaire3D
        Call traitement_iges_function_rect(fic_out, BIBLIOTHEQUE3D.TAB_Poche_Rectangulaire3D(indice))
    Next indice
    
    Call MessageLOG_Print("Ecriture IGES " & indice - 1 & " Rectangle(s)")

  ' Ecriture du fichier IGES
  Call Ecriture_SectionS(fic_out)
  Call Ecriture_SectionG(fic_out)
   
  Call concat(fic_out, fic_out & "~D")
  Call concat(fic_out, fic_out & "~P")
    
  Call Ecriture_SectionT(fic_out, Current_Ligne_uSer, 2, Current_Ligne_Definition - 1, Current_Ligne_Parameter - 1)
          
  'Text_error = "Fin sans Erreur" 'LoadResString(802)
  
fin:
  
  'nettoyage fichier temporaire
  'Kill fic_in
  Kill (fic_out & "~D")
  Kill (fic_out & "~P")
  
  
End Sub


Public Sub traitement_iges_lin(FICHIER As String, P1 As Point3, P2 As Point3)
Dim Line_count As Integer
Dim Ligne As Line3

                    Ligne.B = P1
                    Ligne.M = P2
                    Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                    Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, "Line", 0, 0)

End Sub

Public Function traitement_iges_cir(FICHIER As String, P1 As Point3, P2 As Point3, P3 As Point3) As Boolean

Dim Radius As Double
Dim Normal As Point3
Dim Millieu As Point3

                                
                    Call CircleThreePt(P1, P2, P3, Millieu, Normal)
                    
                    Radius = Distance(P1, Millieu)
   
                    traitement_iges_cir = traitement_iges_ARC(FICHIER, P1, P2, P3, Millieu, Normal, Radius, "Arc", False, 0, 0)
              
End Function
Public Sub traitement_iges_function_circulaire(FICHIER As String, Circulaire As Poche_Circulaire3D)
Dim Pt_Calcule As Interpolation


Dim AlphaFinal As Double
Dim AlphaMilieu As Double
Dim Normal As Point3
Dim Radius As Double

Dim P0 As Point3
Dim P1 As Point3
Dim P2 As Point3
Dim P3 As Point3
Dim P4 As Point3
Dim P5 As Point3
Dim P6 As Point3
Dim P7 As Point3
Dim P8 As Point3
Dim Po1 As Point3
Dim Po2 As Point3
Dim Po3 As Point3
Dim Po4 As Point3
 
Dim Millieu As Point3
Dim Millieu_INVERSE As Point3
Dim Millieu_INVERSE_B As Point3
Dim Matrice As Matrix
Dim MatriceLamage As Matrix
Dim Matrice_Inverse As Matrix
Dim MatriceLamage_Inverse As Matrix

Dim incrA As Double
Dim boucle1 As Double
Dim incrC As Double
Dim boucle2 As Double
 
Dim VEC1 As Point3
Dim VEC2 As Point3
Dim VEC3 As Point3
 
Dim Ligne_axe As Line3
Dim Ligne_rev As Line3
 
Dim Hauteur As Double
Dim Deduction_Profondeur_Lamage As Double
Dim Line_count As Integer
Dim ref_124_axis As Integer
Dim ref_124_axis_B As Integer
Dim ref_124_axis_C As Integer

Dim closest As Point3
Dim Circl As Circle3
Dim Plane_Feature As Plane3
Dim Plane_Lamage As Plane3
Dim MatriceFeature As Matrix
Dim Texte_feature As String
Dim Cercle_Ext_number As Long
Dim Cercle_Int_number As Long
Dim Ext_142_number As Long
Dim Int_142_number As Long
Dim Plane_number As Long
Dim Axis_Revolution_number As Long
Dim Generatrice_number As Long


                    Circl.C = Circulaire.Centre
                    Circl.N = Circulaire.Axes(2)
                    Circl.R = Circulaire.Rayon
                    Hauteur = Circulaire.Hauteur
                    
                    Millieu = Circulaire.Centre
                    VEC2 = VecteurUnitaire(Circulaire.Axes(0))
                    Normal = VecteurUnitaire(Circulaire.Axes(2))
   
                    P1 = VecAdd(Millieu, VEC2, Circl.R)
                    
                                     
                    VEC3 = Circulaire.Axes(1) ' VecteurUnitaire(NormVec(P1, Millieu, P3))
                    
                     'Definition plan du feature
                     Plane_Feature.N = Normal
                     Plane_Feature.D = Dot(Normal, Circl.C)
                     
                    Matrice = RemplirMatrice(VEC2, VEC3, Normal)
  
  
  
                     ' Creation Iges des points
                     Line_count = 1
                     Call Ecriture_SectionP_116(FICHIER & "~P", Circl.C, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     Call Ecriture_SectionD(FICHIER & "~D", 116, Current_Ligne_Parameter, Line_count, 0, 5, 0, 1)
                        
                     MatriceFeature = RemplirMatrice(Circulaire.Axes(0), VecAdd(P0, Circulaire.Axes(1), -1), VecAdd(P0, Circulaire.Axes(2), -1))
                        
                     Line_count = 1
                     Call Ecriture_SectionP_124(FICHIER & "~P", MatriceFeature, Circl.C, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     Call Ecriture_SectionD(FICHIER & "~D", 124, Current_Ligne_Parameter, Line_count, 0, 4, 0, 1)
 
 
                   'Ecriture Axis de ref pour cercle
                    Line_count = 1
                    Call Ecriture_SectionP_124(FICHIER & "~P", Matrice, Millieu, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                    Call Ecriture_SectionD(FICHIER & "~D", 124, Current_Ligne_Parameter, Line_count, 0, 2, 1, 0)
                    ref_124_axis = Current_Ligne_Definition - 2
                    
                    Matrice_Inverse = Invert_Matrice(Matrice)
                    Millieu_INVERSE = Transformation(Matrice_Inverse, Millieu)
                    
                    Po1 = P1
                    Po2.X = 0
                    Po2.Y = 0

                    
                    Call Trans(Matrice_Inverse, Millieu_INVERSE, Po1)
 
            
            ' traitement du lamage
            If Circulaire.Rayon_Lamage > 0 Then
            ' rayon pour lamage
             Deduction_Profondeur_Lamage = Circulaire.Rayon_Lamage
                                    'crer la ligne de l'axe
                       P4 = VecAdd(Millieu, Normal, Hauteur)
                       P5 = VecAdd(Millieu, Normal, Hauteur - Deduction_Profondeur_Lamage)
                       P5 = VecAdd(P5, Circulaire.Axes(0), Circl.R)
                       P6 = VecAdd(Millieu, Normal, Hauteur - Deduction_Profondeur_Lamage)
                       P6 = VecAdd(P6, Circulaire.Axes(0), Circl.R + Circulaire.Rayon_Lamage)
                       
                       Line_count = 1
                       Ligne_axe.B = Millieu
                       Ligne_axe.M = P4
                       Call Ecriture_SectionP_110(FICHIER & "~P", Ligne_axe, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                       Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Lamage"), 0, 0)
                       Axis_Revolution_number = Current_Ligne_Definition - 2
                     
                        MatriceLamage = RemplirMatrice(Normal, VEC2, VEC3)
                        MatriceLamage_Inverse = Invert_Matrice(MatriceLamage)
                   
                       'Crer la gnratrice
                       Millieu_INVERSE_B = Transformation(MatriceLamage_Inverse, P6)
                       'P7=point de dpart du cercle dans le repre absolu
                       'P8=point de dpart du cercle dans le repre absolu
                        P7 = P5
                        P8 = VecAdd(P6, Normal, Deduction_Profondeur_Lamage)
                       
                       'P7=point de dpart du cercle dans la coordonne du repre de transformation
                       'P8=point de dpart du cercle dans la coordonne du repre de transformation
                       Call Trans(MatriceLamage_Inverse, Millieu_INVERSE_B, P7)
                       Call Trans(MatriceLamage_Inverse, Millieu_INVERSE_B, P8)

                       
                       'Ecriture Axis de ref pour cercle
                       Line_count = 1
                       Call Ecriture_SectionP_124(FICHIER & "~P", MatriceLamage, P6, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                       Call Ecriture_SectionD(FICHIER & "~D", 124, Current_Ligne_Parameter, Line_count, 0, 2, 1, 0)
                       ref_124_axis_C = Current_Ligne_Definition - 2
                    
                       'Ecriture Cercle pour surface de rvolution
                       Line_count = 1
                       Call Ecriture_SectionP_100(FICHIER & "~P", Po2, P7, P8, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                       Call Ecriture_SectionD(FICHIER & "~D", 100, Current_Ligne_Parameter, Line_count, ref_124_axis_C, ColorIges("Lamage"), 0, 0)
                       Generatrice_number = Current_Ligne_Definition - 2

                           
                       'Crer la surface de rvolution
                       Line_count = 1
                       Call Ecriture_SectionP_120(FICHIER & "~P", Axis_Revolution_number, Generatrice_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                       Call Ecriture_SectionD(FICHIER & "~D", 120, Current_Ligne_Parameter, Line_count, 0, ColorIges("Lamage"), 0, 0)
             
             
             
            Else
            
                If Circulaire.Diametre_Lamage > Circulaire.Rayon * 2 Then
                   Deduction_Profondeur_Lamage = Circulaire.Prof_Lamage

                     ' chanfrein pour lamage
                    If Circulaire.Angle_Lamage > 0 And Circulaire.Angle_Lamage < 90 Then
                       'crer la ligne de l'axe
                       P4 = VecAdd(Millieu, Normal, Hauteur)
                       P5 = VecAdd(Millieu, Normal, Hauteur - Deduction_Profondeur_Lamage)
                       P5 = VecAdd(P5, Circulaire.Axes(0), Circl.R)
                       P6 = VecAdd(Millieu, Normal, Hauteur)
                       P6 = VecAdd(P6, Circulaire.Axes(0), Circulaire.Diametre_Lamage / 2)
                       
                           Line_count = 1
                           Ligne_axe.B = Millieu
                           Ligne_axe.M = P4
                           Call Ecriture_SectionP_110(FICHIER & "~P", Ligne_axe, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                           Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Lamage"), 0, 0)
                           Axis_Revolution_number = Current_Ligne_Definition - 2
                     
                       'Crer la gnratrice
                           Line_count = 1
                           Ligne_rev.B = P5
                           Ligne_rev.M = P6
                           Call Ecriture_SectionP_110(FICHIER & "~P", Ligne_rev, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                           Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Lamage"), 0, 0)
                           Generatrice_number = Current_Ligne_Definition - 2
                           
                       'Crer la surface de rvolution
                           Line_count = 1
                           Call Ecriture_SectionP_120(FICHIER & "~P", Axis_Revolution_number, Generatrice_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                           Call Ecriture_SectionD(FICHIER & "~D", 120, Current_Ligne_Parameter, Line_count, 0, ColorIges("Lamage"), 0, 0)
 
                       
                    
                    Else
                       ' lamage plat
                       
                       P5 = VecAdd(Millieu, Normal, Hauteur - Deduction_Profondeur_Lamage)
                       P6 = VecAdd(P5, VEC2, Circl.R)
                       Po4 = VecAdd(P5, VEC2, Circulaire.Diametre_Lamage / 2)
                       
                       Millieu_INVERSE_B = Transformation(Matrice_Inverse, P5)
                       P7 = Po4
                       Call Trans(Matrice_Inverse, Millieu_INVERSE_B, P6)
                       Call Trans(Matrice_Inverse, Millieu_INVERSE_B, P7)
                       
                       'Ecriture Axis de ref pour cercle
                       Line_count = 1
                       Call Ecriture_SectionP_124(FICHIER & "~P", Matrice, P5, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                       Call Ecriture_SectionD(FICHIER & "~D", 124, Current_Ligne_Parameter, Line_count, 0, 2, 1, 0)
                        ref_124_axis_B = Current_Ligne_Definition - 2
                    
                    
                       Line_count = 1
                       Call Ecriture_SectionP_100(FICHIER & "~P", Po2, P6, P6, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                       Call Ecriture_SectionD(FICHIER & "~D", 100, Current_Ligne_Parameter, Line_count, ref_124_axis_B, ColorIges("Lamage"), 0, 0)
                       Cercle_Int_number = Current_Ligne_Definition - 2


                       Line_count = 1
                       Call Ecriture_SectionP_100(FICHIER & "~P", Po2, P7, P7, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                       Call Ecriture_SectionD(FICHIER & "~D", 100, Current_Ligne_Parameter, Line_count, ref_124_axis_B, ColorIges("Lamage"), 0, 0)
                    
                       Cercle_Ext_number = Current_Ligne_Definition - 2
                    

                       'Definition plan du lamage
                        Plane_Lamage.N = Normal
                        Plane_Lamage.D = Dot(Normal, P5)
                     
                        'Ecriture du plan mais sans limite
                        Line_count = 1
                        Call Ecriture_SectionP_108(FICHIER & "~P", Plane_Lamage, 0, P5, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 108, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 0, 0, 0)
                        Plane_number = Current_Ligne_Definition - 2
                        
                        'Courbe exterieur 142
                        Line_count = 1
                        Call Ecriture_SectionP_142(FICHIER & "~P", Plane_number, Cercle_Ext_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 142, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 1, 0)
                        Ext_142_number = Current_Ligne_Definition - 2
                        
                        'Courbe interieur 142
                        Line_count = 1
                        Call Ecriture_SectionP_142(FICHIER & "~P", Plane_number, Cercle_Int_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 142, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 1, 0)
                        Int_142_number = Current_Ligne_Definition - 2
                        
                        'Face 144
                        Line_count = 1
                        Call Ecriture_SectionP_144(FICHIER & "~P", Plane_number, Ext_142_number, Int_142_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 144, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond_Lamage"), 0, 0)

                        Po3 = VecAdd(Po4, Normal, Deduction_Profondeur_Lamage)
                        'Ecriture  Tabulated Cylinder
                        Line_count = 1
                        Call Ecriture_SectionP_122(FICHIER & "~P", Po3, Cercle_Ext_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 122, Current_Ligne_Parameter, Line_count, 0, ColorIges("Lamage"), 0, 0)


                    
                    End If
                End If
            End If
            
                    ' Ecriture cercle de base
                    Line_count = 1
                    Call Ecriture_SectionP_100(FICHIER & "~P", Po2, Po1, Po1, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                    Call Ecriture_SectionD(FICHIER & "~D", 100, Current_Ligne_Parameter, Line_count, ref_124_axis, ColorIges("Circulaire"), 0, 0)
                    
                    Cercle_Ext_number = Current_Ligne_Definition - 2
                    
                    
                       P3 = VecAdd(P1, Normal, Hauteur - Deduction_Profondeur_Lamage)
                       Po3 = P3
                       
                    
                    ' traitement cas trou ouvert
                    If Circulaire.Rayon_Fond > 0 And Circulaire.Rayon_Fond < Circulaire.Rayon Then
                     P1 = VecAdd(Millieu, VEC2, Circulaire.Rayon_Fond)
                     Po1 = P1
                     Call Trans(Matrice_Inverse, Millieu_INVERSE, Po1)
                     Line_count = 1
                     Call Ecriture_SectionP_100(FICHIER & "~P", Po2, Po1, Po1, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     Call Ecriture_SectionD(FICHIER & "~D", 100, Current_Ligne_Parameter, Line_count, ref_124_axis, ColorIges("Circulaire"), 0, 0)
                     Cercle_Int_number = Current_Ligne_Definition - 2
                    End If
                    
                   

            'Ecriture  Tabulated Cylinder
            Line_count = 1
            Call Ecriture_SectionP_122(FICHIER & "~P", Po3, Cercle_Ext_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 122, Current_Ligne_Parameter, Line_count, 0, ColorIges("Side"), 0, 0)


            'Ecriture  Plan
            If Circulaire.Rayon_Fond = 0 Then
                        Line_count = 1
                        Call Ecriture_SectionP_108(FICHIER & "~P", Plane_Feature, Cercle_Ext_number, Millieu, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 108, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 0, 0, 1)
 
            Else
                'Entit  144 142
                   If Circulaire.Rayon_Fond < Circulaire.Rayon Then
                        'Ecriture du plan mais sans limite
                        Line_count = 1
                        Call Ecriture_SectionP_108(FICHIER & "~P", Plane_Feature, 0, Millieu, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 108, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 0, 0, 0)
                        Plane_number = Current_Ligne_Definition - 2
                        
                        'Courbe exterieur 142
                        Line_count = 1
                        Call Ecriture_SectionP_142(FICHIER & "~P", Plane_number, Cercle_Ext_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 142, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 1, 0)
                        Ext_142_number = Current_Ligne_Definition - 2
                        
                        'Courbe interieur 142
                        Line_count = 1
                        Call Ecriture_SectionP_142(FICHIER & "~P", Plane_number, Cercle_Int_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 142, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 1, 0)
                        Int_142_number = Current_Ligne_Definition - 2
                        
                        'Face 144
                        Line_count = 1
                        Call Ecriture_SectionP_144(FICHIER & "~P", Plane_number, Ext_142_number, Int_142_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 144, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 0, 0)

                        
                   End If
                   ' cas restant rayon fond > rayon : pas de fond
            End If
            
            
            

            
            
            
            
            'Ecriture  texte
            Line_count = 1
            Texte_feature = Circulaire.NOM & "-" & Circulaire.Hauteur
            Call Ecriture_SectionP_212(FICHIER & "~P", Texte_feature, VecAdd(P1, Normal, Hauteur), Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 212, Current_Ligne_Parameter, Line_count, 0, ColorIges("Texte"), 0, 0)


End Sub


Public Sub traitement_iges_function_slot(FICHIER As String, Slot As Poche_Oblong3D)
Dim Radius As Double
Dim Normal As Point3
Dim Longueur As Double
Dim Large As Double
Dim Hauteur As Double

Dim P0 As Point3
Dim P1 As Point3
Dim P2 As Point3
Dim P3 As Point3

Dim PInit As Point3
Dim Po1 As Point3
Dim Po2 As Point3
 
Dim Pvia1 As Point3
Dim Pvia2 As Point3

Dim Pbegin1 As Point3
Dim Pbegin2 As Point3

Dim Pend1 As Point3
Dim Pend2 As Point3

Dim Pmillieu1 As Point3
Dim Pmillieu2 As Point3

Dim Millieu As Point3
 
Dim VEC1 As Point3
Dim VEC2 As Point3


Dim Plane_Feature As Plane3
Dim Composite_number As Long

Dim Ligne As Line3
Dim Line_count As Integer

Dim Nb_entity As Integer
Dim Ref_Entity(9) As Integer
Dim Texte_feature As String
Dim MatriceFeature As Matrix
                   
                    P1 = Slot.Centre
                    P2 = VecAdd(Slot.Centre, Slot.Axes(2), Slot.Longueurs(2))
                    P3 = VecAdd(Slot.Centre, Slot.Axes(0), Slot.Longueurs(0) / 2)
                    Longueur = Slot.Longueurs(0)
                    Large = Slot.Longueurs(1)
                    Hauteur = Slot.Longueurs(2)
                    Radius = Slot.Longueurs(1) / 2
                    
                       
                    ' Par scurit normaliser
                     VEC1 = VecteurUnitaire(Slot.Axes(0))
                     VEC2 = VecteurUnitaire(Slot.Axes(1))
                     Normal = VecteurUnitaire(Slot.Axes(2))
                     
                     'Definition plan du feature
                     Plane_Feature.N = Normal
                     Plane_Feature.D = Dot(Normal, P1)
                        
                        
                           ' Creation Iges des points
                     'Line_count = 1
                     'Call Ecriture_SectionP_116(Fichier & "~P", P1, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     'Call Ecriture_SectionD(Fichier & "~D", 116, Current_Ligne_Parameter, Line_count, 0, 5, 0, 0)
                     
                     Line_count = 1
                     Call Ecriture_SectionP_116(FICHIER & "~P", P2, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     Call Ecriture_SectionD(FICHIER & "~D", 116, Current_Ligne_Parameter, Line_count, 0, 5, 0, 1)
                        
                     MatriceFeature = RemplirMatrice(Slot.Axes(0), VecAdd(P0, Slot.Axes(1), -1), VecAdd(P0, Slot.Axes(2), -1))
                        
                     Line_count = 1
                     Call Ecriture_SectionP_124(FICHIER & "~P", MatriceFeature, P2, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     Call Ecriture_SectionD(FICHIER & "~D", 124, Current_Ligne_Parameter, Line_count, 0, 4, 0, 1)
                  
                        
                        
                        
                    ' PREMIER POINT
                        PInit = VecAdd(P1, VEC2, (Large / 2))
                        Po1 = VecAdd(P1, VEC1, Longueur / 2)
                        ' rayon
                        Pmillieu1 = VecAdd(Po1, VEC1, -Radius)
                        Pbegin1 = VecAdd(Pmillieu1, VEC2, Radius)
                        Pend1 = VecAdd(Pmillieu1, VEC2, -Radius)
                        Pvia1 = Po1
                        
                    ' DEUXIEME POINT
                        Po2 = VecAdd(P1, VEC1, -Longueur / 2)
                        ' rayon
                        Pmillieu2 = VecAdd(Po2, VEC1, Radius)
                        Pbegin2 = VecAdd(Pmillieu2, VEC2, -Radius)
                        Pend2 = VecAdd(Pmillieu2, VEC2, Radius)
                        Pvia1 = Po2


                      ' PREMIER POINT
                        Line_count = 1
                        Ligne.B = PInit
                        Ligne.M = Pbegin1
                      
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Oblong"), 0, 0)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1
                                                 
                        Call traitement_iges_ARC(FICHIER, Pbegin1, Pvia1, Pend1, Pmillieu1, Normal, Radius, "Oblong", True, 0, 1)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1
                                              
                     
                        ' DEUXIEME POINT
                        Line_count = 1
                        Ligne.B = Pend1
                        Ligne.M = Pbegin2
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Oblong"), 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                     
                      Call traitement_iges_ARC(FICHIER, Pbegin2, Pvia2, Pend2, Pmillieu2, Normal, Radius, "Oblong", True, 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                      
                      ' FERMETURE FIGURE
                        Line_count = 1
                        Ligne.B = Pend2
                        Ligne.M = PInit
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Oblong"), 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                        
                      
            'Ecriture  Composite curve
            Line_count = 1
            Call Ecriture_SectionP_102(FICHIER & "~P", Nb_entity, Ref_Entity, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 102, Current_Ligne_Parameter, Line_count, 0, ColorIges("Oblong"), 0, 0)
            Composite_number = Current_Ligne_Definition - 2
            
            'Ecriture  Tabulated cylinder
            Line_count = 1
            Call Ecriture_SectionP_122(FICHIER & "~P", VecAdd(PInit, Normal, Hauteur), Composite_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 122, Current_Ligne_Parameter, Line_count, 0, ColorIges("Side"), 0, 0)

            'Ecriture  Plan
            Line_count = 1
            Call Ecriture_SectionP_108(FICHIER & "~P", Plane_Feature, Composite_number, P1, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 108, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 0, 0)

            'Ecriture  texte
            Line_count = 1
            Texte_feature = Slot.NOM & "-" & Slot.Longueurs(2)
            Call Ecriture_SectionP_212(FICHIER & "~P", Texte_feature, VecAdd(P1, Normal, Hauteur), Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 212, Current_Ligne_Parameter, Line_count, 0, ColorIges("Texte"), 0, 0)


End Sub

Public Sub traitement_iges_function_rect(FICHIER As String, Rectangle As Poche_Rectangulaire3D)
Dim Radius As Double
Dim Normal As Point3
Dim Longueur As Double
Dim Large As Double
Dim Hauteur As Double

Dim P0 As Point3
Dim P1 As Point3
Dim P2 As Point3
Dim P3 As Point3

Dim PInit As Point3
Dim Po1 As Point3
Dim Po2 As Point3
Dim Po3 As Point3
Dim Po4 As Point3
 
Dim Pvia1 As Point3
Dim Pvia2 As Point3
Dim Pvia3 As Point3
Dim Pvia4 As Point3

Dim Pbegin1 As Point3
Dim Pbegin2 As Point3
Dim Pbegin3 As Point3
Dim Pbegin4 As Point3

Dim Pend1 As Point3
Dim Pend2 As Point3
Dim Pend3 As Point3
Dim Pend4 As Point3

Dim Pmillieu1 As Point3
Dim Pmillieu2 As Point3
Dim Pmillieu3 As Point3
Dim Pmillieu4 As Point3

Dim Millieu As Point3
 
Dim VEC1 As Point3
Dim VEC2 As Point3
Dim VEC3 As Point3

Dim Plane_Feature As Plane3
Dim Composite_number As Long
Dim MatriceFeature As Matrix

Dim Ligne As Line3
Dim Line_count As Integer
Dim Texte_feature As String
Dim Nb_entity As Integer
Dim Ref_Entity(9) As Integer

                   
                    'Call decodage_rect(LigneIN, P1, P2, P3, Large, Radius, Rest)
                    P1 = Rectangle.Centre
                    P2 = VecAdd(Rectangle.Centre, Rectangle.Axes(2), Rectangle.Longueurs(2))
                    P3 = VecAdd(Rectangle.Centre, Rectangle.Axes(0), Rectangle.Longueurs(0) / 2)
                    P3 = VecAdd(P3, Rectangle.Axes(0), -Rectangle.Rayon)
                    Longueur = Rectangle.Longueurs(0)
                    Large = Rectangle.Longueurs(1)
                    Hauteur = Rectangle.Longueurs(2)
                    Radius = Rectangle.Rayon
                    
                    ' Par scurit normaliser
                     VEC1 = VecteurUnitaire(Rectangle.Axes(0))
                     VEC2 = VecteurUnitaire(Rectangle.Axes(1))
                     Normal = VecteurUnitaire(Rectangle.Axes(2))
                     
                     'Definition plan du feature
                     Plane_Feature.N = Normal
                     Plane_Feature.D = Dot(Normal, P1)
                     
                     ' Creation Iges des points
                     'Line_count = 1
                     'Call Ecriture_SectionP_116(Fichier & "~P", P1, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     'Call Ecriture_SectionD(Fichier & "~D", 116, Current_Ligne_Parameter, Line_count, 0, 5, 0, 0)
                     
                     Line_count = 1
                     Call Ecriture_SectionP_116(FICHIER & "~P", P2, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     Call Ecriture_SectionD(FICHIER & "~D", 116, Current_Ligne_Parameter, Line_count, 0, 5, 0, 1)
                        
                     MatriceFeature = RemplirMatrice(Rectangle.Axes(0), VecAdd(P0, Rectangle.Axes(1), -1), VecAdd(P0, Rectangle.Axes(2), -1))
                        
                     Line_count = 1
                     Call Ecriture_SectionP_124(FICHIER & "~P", MatriceFeature, P2, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                     Call Ecriture_SectionD(FICHIER & "~D", 124, Current_Ligne_Parameter, Line_count, 0, 4, 0, 1)
                      

                        
                        ' PREMIER POINT
                        PInit = VecAdd(P1, VEC2, (Large / 2))
                        Po1 = VecAdd(PInit, VEC1, Longueur / 2)
                        ' rayon
                        Pbegin1 = VecAdd(Po1, VEC1, -Radius)
                        Pend1 = VecAdd(Po1, VEC2, -Radius)
                        Pmillieu1 = VecAdd(Pend1, VEC1, -Radius)
                        
                        VEC3 = VecteurUnitaire(VecSub(Po1, Pmillieu1))
                        Pvia1 = VecAdd(Pmillieu1, VEC3, Radius)
                        
                    ' DEUXIEME POINT
                        Po2 = VecAdd(Po1, VEC2, -Large)
                        ' rayon
                        Pbegin2 = VecAdd(Po2, VEC2, Radius)
                        Pend2 = VecAdd(Po2, VEC1, -Radius)
                        Pmillieu2 = VecAdd(Pend2, VEC2, Radius)
                        
                        VEC3 = VecteurUnitaire(VecSub(Po2, Pmillieu2))
                        Pvia2 = VecAdd(Pmillieu2, VEC3, Radius)
                    
                    ' TROISIEME POINT
                        Po3 = VecAdd(Po2, VEC1, -Longueur)
                        ' rayon
                        Pbegin3 = VecAdd(Po3, VEC1, Radius)
                        Pend3 = VecAdd(Po3, VEC2, Radius)
                        Pmillieu3 = VecAdd(Pend3, VEC1, Radius)
                        
                        VEC3 = VecteurUnitaire(VecSub(Po3, Pmillieu3))
                        Pvia3 = VecAdd(Pmillieu3, VEC3, Radius)
                    
                    ' QUATRIEME POINT
                        Po4 = VecAdd(Po3, VEC2, Large)
                        ' rayon
                        Pbegin4 = VecAdd(Po4, VEC2, -Radius)
                        Pend4 = VecAdd(Po4, VEC1, Radius)
                        Pmillieu4 = VecAdd(Pend4, VEC2, -Radius)
                        
                        VEC3 = VecteurUnitaire(VecSub(Po4, Pmillieu4))
                        Pvia4 = VecAdd(Pmillieu4, VEC3, Radius)
                        

                    
                    
                    If Radius <= 0 Then
                      ' PREMIER POINT
                        Line_count = 1
                        Ligne.B = PInit
                        Ligne.M = Po1
                      
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 0)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1
                            
                
                        ' DEUXIEME POINT
                        Line_count = 1
                        Ligne.B = Po1
                        Ligne.M = Po2
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1
                            
                                           
                      
                      ' TROISIEME POINT
                        Line_count = 1
                        Ligne.B = Po2
                        Ligne.M = Po3
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1

                                                                 
                       ' QUATRIEME POINT
                        Line_count = 1
                        Ligne.B = Po3
                        Ligne.M = Po4
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1
                     
                       ' FERMETURE FIGURE
                        Line_count = 1
                        Ligne.B = Po4
                        Ligne.M = PInit
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1

                    Else
                    

                   
                      ' PREMIER POINT
                        Line_count = 1
                        Ligne.B = PInit
                        Ligne.M = Pbegin1
                      
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 0)
                        Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                        Nb_entity = Nb_entity + 1
                                                 
                      Call traitement_iges_ARC(FICHIER, Pbegin1, Pvia1, Pend1, Pmillieu1, Normal, Radius, "Rectangle", True, 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                                              
                     
                          ' DEUXIEME POINT
                        Line_count = 1
                        Ligne.B = Pend1
                        Ligne.M = Pbegin2
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                            
                     
                      Call traitement_iges_ARC(FICHIER, Pbegin2, Pvia2, Pend2, Pmillieu2, Normal, Radius, "Rectangle", True, 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                      
                      
                      ' TROISIEME POINT
                        Line_count = 1
                        Ligne.B = Pend2
                        Ligne.M = Pbegin3
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1

                     
                      Call traitement_iges_ARC(FICHIER, Pbegin3, Pvia3, Pend3, Pmillieu3, Normal, Radius, "Rectangle", True, 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                      
                      ' QUATRIEME POINT
                        Line_count = 1
                        Ligne.B = Pend3
                        Ligne.M = Pbegin4
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                     
                      Call traitement_iges_ARC(FICHIER, Pbegin4, Pvia4, Pend4, Pmillieu4, Normal, Radius, "Rectangle", True, 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                      
                      ' FERMETURE FIGURE
                        Line_count = 1
                        Ligne.B = Pend4
                        Ligne.M = PInit
                        Call Ecriture_SectionP_110(FICHIER & "~P", Ligne, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                        Call Ecriture_SectionD(FICHIER & "~D", 110, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 1)
                      Ref_Entity(Nb_entity) = Current_Ligne_Definition - 2
                      Nb_entity = Nb_entity + 1
                        

                      End If
                      
            'Ecriture  Composite curve
            Line_count = 1
            Call Ecriture_SectionP_102(FICHIER & "~P", Nb_entity, Ref_Entity, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 102, Current_Ligne_Parameter, Line_count, 0, ColorIges("Rectangle"), 0, 0)
            Composite_number = Current_Ligne_Definition - 2
            'Ecriture  tabulated cylinder
            Line_count = 1
            Call Ecriture_SectionP_122(FICHIER & "~P", VecAdd(PInit, Normal, Hauteur), Composite_number, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 122, Current_Ligne_Parameter, Line_count, 0, ColorIges("Side"), 0, 0)

            'Ecriture  Plan
            Line_count = 1
            Call Ecriture_SectionP_108(FICHIER & "~P", Plane_Feature, Composite_number, P1, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 108, Current_Ligne_Parameter, Line_count, 0, ColorIges("Fond"), 0, 0)

            'Ecriture  texte
            Line_count = 1
            Texte_feature = Rectangle.NOM & "-" & Rectangle.Longueurs(2)
            Call Ecriture_SectionP_212(FICHIER & "~P", Texte_feature, VecAdd(P1, Normal, Hauteur), Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
            Call Ecriture_SectionD(FICHIER & "~D", 212, Current_Ligne_Parameter, Line_count, 0, ColorIges("Texte"), 0, 0)

End Sub

'traitement_iges d'un arc par 3 points

Public Function traitement_iges_ARC(FICHIER As String, P1 As Point3, P2 As Point3, P3 As Point3, Millieu As Point3, Normal As Point3, Radius As Double, Type_Origine As String, Utilisation_CodeG As Boolean, Visible As Integer, Dependant As Integer) As Boolean
Dim Rest As String
Dim VAR As String

Dim AlphaFinal As Double
Dim AlphaMilieu As Double



Dim Po1 As Point3
Dim Po2 As Point3
Dim Po3 As Point3

Dim VEC1 As Point3
Dim VEC2 As Point3
Dim VEC3 As Point3

Dim Millieu_INVERSE As Point3
Dim Matrice As Matrix
Dim Matrice_Inverse As Matrix
Dim incr As Double
Dim incrA As Double
Dim boucle1 As Double
Dim incrC As Double
Dim boucle2 As Double
 
Dim deg As Double
 
Dim res As Integer
Dim Alpha As Double
Dim Line_count As Integer

Dim ref_124_axis As Integer


                    
                    
                    VEC2 = VecAdd(Millieu, Normal, 1)
                    VEC3 = NormVec(VEC2, Millieu, P1)
                    VEC2 = VecteurUnitaire(VecSub(P1, Millieu))
  
                    Matrice = RemplirMatrice(VEC2, VEC3, Normal)

                    Line_count = 1
                    Call Ecriture_SectionP_124(FICHIER & "~P", Matrice, Millieu, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                    Call Ecriture_SectionD(FICHIER & "~D", 124, Current_Ligne_Parameter, Line_count, 0, 2, 1, 0)
                    
                    ref_124_axis = Current_Ligne_Definition - 2
                    
                    Matrice_Inverse = Invert_Matrice(Matrice)
                    Millieu_INVERSE = Transformation(Matrice_Inverse, Millieu)
                    
                    Po1 = P1
                    
                    Po2.X = 0
                    Po2.Y = 0
                    
                    Po3 = P3
                    
                    Call Trans(Matrice_Inverse, Millieu_INVERSE, Po1)
                    Call Trans(Matrice_Inverse, Millieu_INVERSE, Po3)
 
                    Line_count = 1
                    Call Ecriture_SectionP_100(FICHIER & "~P", Po2, Po1, Po3, Current_Ligne_Parameter, Current_Ligne_Definition, Line_count)
                    Call Ecriture_SectionD(FICHIER & "~D", 100, Current_Ligne_Parameter, Line_count, ref_124_axis, ColorIges(Type_Origine), Visible, Dependant)
                     
traitement_iges_ARC = True
                    
End Function
'Mise a jour des variables pour le log
' et creation de la base graphique
Function ColorIges(CodeForme As String) As Integer

Dim coul As Integer


  ' Color Number
        '0 No color
        '1 Black
        '2 Red
        '3 Green
        '4 Blue
        '5 Yellow
        '6 Magenta
        '7 Cyan
        '8 White
   
   
  ' Affectation des couleurs
   Select Case CodeForme
        Case "Rectangle"
            coul = 2 ' Red
            
        Case "Oblong"
            coul = 5 ' Red
            
        Case "Circulaire"
            coul = 7 ' Cyan
            
        Case "Yellow"
            coul = 5 'Yellow
        
        Case "Lamage"
            coul = 4 ' Blue
        
        Case "Fond_Lamage"
            coul = 5 'Yellow
            
        Case "Fond"
            coul = 3 ' Green
             
        Case "Side"
             coul = 4 ' Blue
        
        Case "Texte"
            coul = 1 ' Black
            
        Case "Green"
            coul = 3 ' Green
        
        Case "Blue"
            coul = 4 ' Blue
            
        Case "Magenta"
            coul = 6 'Magenta
            
            
        Case "Red"
            coul = 2 'Red
            
        Case "Cyan"
            coul = 7 ' Cyan
        
        Case "White"
            coul = 7 ' Cyan

        Case Else
            coul = 8 ' White
        End Select
        

ColorIges = coul
End Function

' Initialisation de variables
Sub InitVal()
    RADTODEG = 180 / (4 * Atn(1))
    DEGTORAD = (4 * Atn(1)) / 180
    'init variable_log
    PMIN.Coord.X = 999999
    PMIN.Coord.Y = 999999
    PMIN.Coord.Z = 999999
    PMAX.Coord.X = -999999
    PMAX.Coord.Y = -999999
    PMAX.Coord.Z = -999999
End Sub




Sub CutLine(A1 As Point3, R1 As Point3, A2 As Point3, R2 As Point3, L As Double, s As Point3, res As Integer)
Dim N As Point3
Dim val As Double

'Produit vectoriel

 N.X = R1.Y * R2.Z - R1.Z * R2.Y
 N.Y = R1.Z * R2.X - R1.X * R2.Z
 N.Z = R1.Y * R2.X - R1.X * R2.Y
 
  
 If Not IsNull(Longueur(N)) Then
  If (Abs(N.Z) >= Abs(N.X)) And (Abs(N.Z) >= Abs(N.Y)) Then
        L = (R1.X * (A2.Y - A1.Y) - R1.Y * (A2.X - A1.X)) / N.Z
  ElseIf (Abs(N.Y) >= Abs(N.X)) Then
        L = (R1.X * (A2.Z - A1.Z) - R1.Z * (A2.X - A1.X)) / N.Y
  Else
        L = (R1.Z * (A2.Y - A1.Y) - R1.Y * (A2.Z - A1.Z)) / N.X
  End If
   
  s = VecAdd(A2, R2, L)
  res = 0
 Else
  res = 1
  L = 0
 End If
End Sub

'Controle point colinaire
Function ControlColPt(P1 As Point3, P2 As Point3, P3 As Point3) As Double

Dim A As Point3
Dim B As Point3
Dim Nv As Point3


 A.X = P1.X - P2.X
 A.Y = P1.Y - P2.Y
 A.Z = P1.Z - P2.Z
 B.X = P3.X - P2.X
 B.Y = P3.Y - P2.Y
 B.Z = P3.Z - P2.Z
 Nv = VecProd(A, B)

 ControlColPt = Sqr((Nv.X) ^ 2 + (Nv.Y) ^ 2 + (Nv.Z) ^ 2)


End Function


' Calcul un cercle par 3 points

Sub CircleThreePt(P1 As Point3, P2 As Point3, P3 As Point3, Mp As Point3, Norm As Point3)

 Dim Nv As Point3
 Dim Rv1 As Point3
 Dim Rv2  As Point3
 Dim Fp1 As Point3
 Dim Fp2 As Point3
 Dim Lambda As Double
 Dim res As Integer

 '-Normale + Mittelpunkt + Radius bestimmen--------------------------*/
  Nv = NormVec(P3, P2, P1)
  
 Norm = Nv

 Rv1 = VecSub(P2, P1)
 Rv1 = VecProd(Rv1, Nv)
 Fp1 = PointMillieu(P1, P2)
 Rv2 = VecSub(P3, P2)
 Rv2 = VecProd(Rv2, Nv)
 Fp2 = PointMillieu(P2, P3)
 
 Call CutLine(Fp1, Rv1, Fp2, Rv2, Lambda, Mp, res)

 
 If (res) Then
    MsgBox LoadResString(402)
    End
 End If
End Sub


Public Sub DegreesToXY(degree As Double, Radius As Double, Point1 As Point3)
    Dim convert As Double
    convert = 4 * Atn(1) / 180
    '     'pi divided by 180
    Point1.X = (Cos(degree * convert) * Radius)
    Point1.Y = (Sin(degree * convert) * Radius)
    Point1.Z = 0
End Sub



'****************************************************************
' Name: increment_angulaire
'
' Par Rapport a un rayon et une erreur cordale retourne
' l' increment angulaire necessaire pour avoir cette valeur
' Returns:valeur de l'increment si incr=0 alors retourne 0.1
' Assumes: ACOS
' Side Effects:None
'
'****************************************************************
Function increment_angulaire(R As Double, Corde As Double) As Double
Dim Angle As Double
Dim incr As Double

Angle = 2 * ACOS(1 - (Corde / R))
incr = Round(((Angle / (4 * Atn(1))) * 180), 0)
' 'debug.print "Angle incremt " & Round(((angle / (4 * Atn(1))) * 180), 0)
 If incr = 0 Then
 increment_angulaire = 0.1
 Else
 increment_angulaire = incr
 End If
End Function

'Threshold for closeness of input point P to normal line C+t*N where C is
' the circle center and N is the normal of plane containing circle.  When
' P is on this line, then all circle points are equidistant from P and I
' return the point 'circleAllClosest'.

Function Dist(X As Double) As Double
    Dist = Sqr(Abs(X))
End Function

'---------------------------------------------------------------------------
Function MinPointCircle(p As Point3, circ As Circle3, closest As Point3) As Double
    ' signed distance from p to plane of circle
     Dim pdiff As Point3
     Dim qdiff As Point3
     Dim diff As Point3
     Dim qlensqr As Double
     Dim pdist As Double
     Dim allClosest As Point3
    
     allClosest.X = INFINITY
     allClosest.Y = INFINITY
     allClosest.Z = INFINITY
    
     pdiff = VecSub(p, circ.C)
     pdist = Dot(circ.N, pdiff)

     'projection of P-C onto plane is Q-C = P-C - (pdist)*N
     qdiff = VecAdd(pdiff, circ.N, -pdist)
     qlensqr = Dot(qdiff, qdiff)
    
    If (qlensqr >= Tolerance) Then
        closest = VecAdd(circ.C, qdiff, (circ.R / Sqr(qlensqr)))
        diff = VecSub(p, closest)
        MinPointCircle = Dist(Dot(diff, diff))
    Else
        closest = allClosest
        MinPointCircle = Dist(circ.R * circ.R + pdist * pdist)
    End If
    
End Function


'Calcul du dterminant d'une matrice 3x3
Function Determinant(M As Matrix) As Double
' Call PrintMatrix(M)
    Determinant = M.A1 * (M.B2 * M.C3 - M.C2 * M.B3) - M.A2 * (M.B1 * M.C3 - M.C1 * M.B3) + M.A3 * (M.B1 * M.C2 - M.C1 * M.B2)
End Function
'Invertion d'une matrice 3x3
Function Invert_Matrice(M1 As Matrix) As Matrix
Dim deter As Double
Dim M2 As Matrix
        deter = Determinant(M1)
        
        M2.A1 = (M1.B2 * M1.C3 - M1.B3 * M1.C2) / deter
        M2.B1 = -1 * (M1.B1 * M1.C3 - M1.B3 * M1.C1) / deter
        M2.C1 = (M1.B1 * M1.C2 - M1.B2 * M1.C1) / deter
        
        M2.A2 = -1 * (M1.A2 * M1.C3 - M1.A3 * M1.C2) / deter
        M2.B2 = (M1.A1 * M1.C3 - M1.A3 * M1.C1) / deter
        M2.C2 = -1 * (M1.A1 * M1.C2 - M1.A2 * M1.C1) / deter
        
        M2.A3 = (M1.A2 * M1.B3 - M1.A3 * M1.B2) / deter
        M2.B3 = -1 * (M1.A1 * M1.B3 - M1.A3 * M1.B1) / deter
        M2.C3 = (M1.A1 * M1.B2 - M1.A2 * M1.B1) / deter

Invert_Matrice = M2
End Function
' Transformation matriciel (rotation + translation )
Sub Trans(M1 As Matrix, PM As Point3, P1 As Point3)
Dim P2 As Point3
    P2.X = P1.X * M1.A1 + P1.Y * M1.A2 + P1.Z * M1.A3
    P2.Y = P1.X * M1.B1 + P1.Y * M1.B2 + P1.Z * M1.B3
    P2.Z = P1.X * M1.C1 + P1.Y * M1.C2 + P1.Z * M1.C3
    
    P1 = VecSub(P2, PM)
    
End Sub
' Transformation matriciel inverse (rotation - translation )
Sub TransInverse(M1 As Matrix, PM As Point3, P1 As Point3)
Dim P2 As Point3

    P2.X = P1.X * M1.A1 + P1.Y * M1.A2 + P1.Z * M1.A3
    P2.Y = P1.X * M1.B1 + P1.Y * M1.B2 + P1.Z * M1.B3
    P2.Z = P1.X * M1.C1 + P1.Y * M1.C2 + P1.Z * M1.C3
    P1 = VecAdd(P2, PM)
End Sub
' Transformation matriciel
Function Transformation(M1 As Matrix, P1 As Point3) As Point3
Dim P2 As Point3
    P2.X = P1.X * M1.A1 + P1.Y * M1.A2 + P1.Z * M1.A3
    P2.Y = P1.X * M1.B1 + P1.Y * M1.B2 + P1.Z * M1.B3
    P2.Z = P1.X * M1.C1 + P1.Y * M1.C2 + P1.Z * M1.C3
    Transformation = P2
End Function

Function RemplirMatrice(P1 As Point3, P2 As Point3, P3 As Point3) As Matrix
Dim Matrice As Matrix

                    Matrice.A1 = P1.X
                    Matrice.B1 = P1.Y
                    Matrice.C1 = P1.Z
                    Matrice.A2 = P2.X
                    Matrice.B2 = P2.Y
                    Matrice.C2 = P2.Z
                    Matrice.A3 = P3.X
                    Matrice.B3 = P3.Y
                    Matrice.C3 = P3.Z
  
  RemplirMatrice = Matrice
End Function
              

